<?php

namespace App\Http\Requests\Contract;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class GenerateContractRequest extends FormRequest
{
    public function authorize(): bool
    {
        return true;
    }

    public function rules(): array
    {
        return [
            'contrato' => 'required|string',  // ID o nombre de la plantilla
            'variables' => 'required|array',  // Variables dinámicas para el contrato
        ];
    }

    public function messages(): array
    {
        return [
            'contrato.required' => 'El campo contrato es obligatorio.',
            'contrato.string'   => 'El campo contrato debe ser una cadena de texto.',
            'variables.required'=> 'El campo variables es obligatorio.',
            'variables.array'   => 'El campo variables debe ser un arreglo válido.',
        ];
    }

    protected function failedValidation(Validator $validator)
    {
        throw new HttpResponseException(response()->json([
            'success' => false,
            'message' => 'Errores de validación',
            'errors' => $validator->errors(),
        ], 422));
    }
}
